#include "algorithm.h++" // NAME::solve NAME::check
#include <cassert> // assert macro
#include <iterator> // std::distance
#include "point.h++" // point
#include <vector> // std::vector

int main() {
  using P = point<int>;
  using S = std::vector<P>;
  using I = typename S::iterator;

  S bag{P(0, 0), P(0, 1), P(0, 2), P(0, 1)};
  I rest = NAME::solve(bag.begin(), bag.end());
  auto h = std::distance(bag.begin(), rest);
  assert(h == 2);
  assert(NAME::check(bag.begin(), bag.end()));
}